diff --git a/README b/README
index 024d39531..055935917 100644
--- a/README
+++ b/README
@@ -1,3 +1,85 @@
+_______________________
+SUPPORTED FS LIST
+_______________________
+
+History
+-------
+
+Firstly, xfstests is the old name of this project, due to it was originally
+developed for testing the XFS file system on the SGI's Irix operating system.
+With xfs was ported to Linux, so was xfstests, now it only supports Linux.
+
+As xfstests has some test cases are good to run on some other filesystems,
+we call them "generic" (and "shared", but it has been removed) cases, you
+can find them in tests/generic/ directory. Then more and more filesystems
+started to use xfstests, and contribute patches. Today xfstests is used
+as a file system regression test suite for lots of Linux's major file systems.
+So it's not "xfs"tests only, we tend to call it "fstests" now.
+
+Supported fs
+------------
+
+Firstly, there's not hard restriction about which filesystem can use fstests.
+Any filesystem can give fstests a try.
+
+Although fstests supports many filesystems, they have different support level
+by fstests. So mark it with 4 levels as below:
+
+L1: Fstests can be run on the specified fs basically.
+L2: Rare support from the specified fs list to fix some generic test failures.
+L3: Normal support from the specified fs list, has some own cases.
+L4: Active support from the fs list, has lots of own cases.
+
++------------+-------+---------------------------------------------------------+
+| Filesystem | Level |                       Comment                           |
++------------+-------+---------------------------------------------------------+
+| AFS        |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Bcachefs   |  L1+  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Btrfs      |  L4   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Ceph       |  L2   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| CIFS       |  L2-  | https://wiki.samba.org/index.php/Xfstesting-cifs        |
++------------+-------+---------------------------------------------------------+
+| Ext2/3/4   |  L3+  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Exfat      |  L1+  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| f2fs       |  L3-  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| FUSE       |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| GFS2       |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Glusterfs  |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| JFS        |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| NFS        |  L2+  | https://linux-nfs.org/wiki/index.php/Xfstests           |
++------------+-------+---------------------------------------------------------+
+| ocfs2      |  L2-  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| overlay    |  L3   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| pvfs2      |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Reiser4    |  L1   | Reiserfs has been removed, only left reiser4            |
++------------+-------+---------------------------------------------------------+
+| tmpfs      |  L3-  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| ubifs      |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| udf        |  L1+  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| Virtiofs   |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| XFS        |  L4+  | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+| 9p         |  L1   | N/A                                                     |
++------------+-------+---------------------------------------------------------+
+
 _______________________
 BUILDING THE FSQA SUITE
 _______________________